Bug 41196 - worker mpm usage of apr's memory pools is not thread-safe
Summary: worker mpm usage of apr's memory pools is not thread-safe
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: mpm_worker (show other bugs)
Version: 2.2-HEAD
Hardware: Other other
: P2 normal with 2 votes (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate, PatchAvailable
Depends on:
Blocks:
 
Reported: 2006-12-17 11:33 UTC by Davi Arnaut
Modified: 2018-11-07 21:08 UTC (History)
0 users



Attachments
worker pchild pool thread usage (5.08 KB, patch)
2006-12-17 11:34 UTC, Davi Arnaut
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Davi Arnaut 2006-12-17 11:33:19 UTC
Move the worker_queue to be created on the child rather than on the worker threads.
Also avoid using the child pool, it's not thread-safe.
Comment 1 Davi Arnaut 2006-12-17 11:34:48 UTC
Created attachment 19275 [details]
worker pchild pool thread usage
Comment 2 Sander de Boer 2009-03-31 01:08:32 UTC
I have upgraded my apache 2.2.6 (solaris 10) box with the prefork mpm to apache 2.2.11 with the worker mpm. It's a reverse proxy for 2 backend tomcat(ajp) servers. Apache is also used as balancer.

<Proxy balancer://patmos>
  BalancerMember ajp://tomcat2:8009 route=mmbase01 min=5 smax=10 max=15
  BalancerMember ajp://tomcat1:8009 route=mmbase02 min=5 smax=10 max=15
</Proxy>

Since this upgrade apache serves sometimes wrong content. It seems that the served content comes from another thread.
Comment 3 Rainer Jung 2009-03-31 01:12:49 UTC
Which version of Tomcat do you use?
Are you using the so-called tcnative or APR connector inside Tomcat?
Comment 4 Sander de Boer 2009-03-31 01:22:56 UTC
I am using the default APR connector with tomcat 6.0.16.
Comment 5 Rainer Jung 2009-03-31 02:17:23 UTC
Can you disable the APR connector to check, whether the problem goes away? There have been a few reports of this problem against mod_jk, and in all cases which could be resolved, the reason was the APR connector.

In case removing APR helps, we will reassign your bug report to tomcat and try to solve the problem there.
Comment 6 Sander de Boer 2009-03-31 02:22:17 UTC
but with apache 2.2.6 with the prefork mpm, everything work okay. So, why is this a tomcat related bug?
Comment 7 Sander de Boer 2009-04-01 00:21:46 UTC
My comments above are not related to this issue. My problems are introduced in 2.2.11. Sorry!
I will open an new issue.
Comment 8 William A. Rowe Jr. 2018-11-07 21:08:36 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.